using System;
using System.Collections;
using System.Text;
using System.Xml;

namespace Berkeley.CS160.ExperienceLogger.Contexts
{
    public class CompoundContext : ADefaultContext
    {
        IList m_contexts = new ArrayList();

        public CompoundContext(params IContext[] contexts) : this("compound",null) { }
        
        public CompoundContext(string name, params IContext[] contexts) : base("compound",name)
        {
            foreach (IContext context in contexts)
            {
                m_contexts.Add(context);
            }
        }

        public IList Contexts
        {
            get { return m_contexts; }
        }

        public override XmlNode CreateDescription(Logger logger)
        {
            XmlNode node = CreateDefaultDescription(logger);

            foreach (IContext context in m_contexts)
            {
                node.AppendChild(context.CreateDescription(logger));
            }

            return node;
        }
    }
}
