using System;
using System.Collections;
using System.Text;
using System.Windows.Forms;
using System.Xml;

namespace Berkeley.CS160.ExperienceLogger.Questions
{
    public abstract class AQuestionInstance
    {
        private AQuestion m_parent;
        private IList m_promptInstances;

        public AQuestionInstance(AQuestion parent)
        {
            m_parent = parent;
            m_promptInstances = new ArrayList();

            foreach (IPrompt prompt in parent.Prompts)
            {
                m_promptInstances.Add(prompt.CreateInstance());
            }
        }

        public IList PromptInstances { get { return m_promptInstances; } }
        public AQuestion Parent { get { return m_parent; } }

        public abstract DialogResult ShowControl();

        public virtual XmlNode GetResponse(Logger logger)
        {
            XmlNode node = logger.CreateElement("Question");

            XmlAttribute nameAtt = logger.CreateAttribute("name");
            nameAtt.Value = Parent.Name;
            node.Attributes.Append(nameAtt);

            foreach (IPromptInstance pi in m_promptInstances)
            {
                node.AppendChild(pi.GetResponse(logger));
            }

            return node;
        }
    }
}
